# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

from waflib import Task,Errors,Utils
from waflib.TaskGen import taskgen_method,before_method
@taskgen_method
def add_gdbus_file(self,filename,prefix,namespace,export=False):
	if not hasattr(self,'gdbus_lst'):
		self.gdbus_lst=[]
	if not'process_gdbus'in self.meths:
		self.meths.append('process_gdbus')
	self.gdbus_lst.append([filename,prefix,namespace,export])
@before_method('process_source')
def process_gdbus(self):
	output_node=self.path.get_bld().make_node(['gdbus',self.get_name()])
	sources=[]
	for filename,prefix,namespace,export in getattr(self,'gdbus_lst',[]):
		node=self.path.find_resource(filename)
		if not node:
			raise Errors.WafError('file not found '+filename)
		c_file=output_node.find_or_declare(node.change_ext('.c').name)
		h_file=output_node.find_or_declare(node.change_ext('.h').name)
		tsk=self.create_task('gdbus_binding_tool',node,[c_file,h_file])
		tsk.cwd=output_node.abspath()
		tsk.env.GDBUS_CODEGEN_INTERFACE_PREFIX=prefix
		tsk.env.GDBUS_CODEGEN_NAMESPACE=namespace
		tsk.env.GDBUS_CODEGEN_OUTPUT=node.change_ext('').name
		sources.append(c_file)
	if sources:
		output_node.mkdir()
		self.source=Utils.to_list(self.source)+sources
		self.includes=[output_node]+self.to_incnodes(getattr(self,'includes',[]))
		if export:
			self.export_includes=[output_node]+self.to_incnodes(getattr(self,'export_includes',[]))
class gdbus_binding_tool(Task.Task):
	color='BLUE'
	ext_out=['.h','.c']
	run_str='${GDBUS_CODEGEN} --interface-prefix ${GDBUS_CODEGEN_INTERFACE_PREFIX} --generate-c-code ${GDBUS_CODEGEN_OUTPUT} --c-namespace ${GDBUS_CODEGEN_NAMESPACE} --c-generate-object-manager ${SRC[0].abspath()}'
	shell=True
def configure(conf):
	conf.find_program('gdbus-codegen',var='GDBUS_CODEGEN')
