# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

import os
from waflib import Task,TaskGen,Options,Errors,Utils,Logs
from waflib.Tools import ccroot
JAR_RE='**/*'
def _process_use_rec(self,name):
	if name in self.javatest_use_not or name in self.javatest_use_seen:
		return
	try:
		tg=self.bld.get_tgen_by_name(name)
	except Errors.WafError:
		self.javatest_use_not.add(name)
		return
	self.javatest_use_seen.append(name)
	tg.post()
	for n in self.to_list(getattr(tg,'use',[])):
		_process_use_rec(self,n)
@TaskGen.feature('javatest')
@TaskGen.after_method('process_source','apply_link','use_javac_files')
def javatest_process_use(self):
	self.javatest_use_not=set()
	self.javatest_use_seen=[]
	self.javatest_libpaths=[]
	self.javatest_pypaths=[]
	self.javatest_dep_nodes=[]
	names=self.to_list(getattr(self,'use',[]))
	for name in names:
		_process_use_rec(self,name)
	def extend_unique(lst,varlst):
		ext=[]
		for x in varlst:
			if x not in lst:
				ext.append(x)
		lst.extend(ext)
	for name in self.javatest_use_seen:
		tg=self.bld.get_tgen_by_name(name)
		if'py'in tg.features:
			pypath=getattr(tg,'install_from',tg.path)
			if'buildcopy'in tg.features:
				extend_unique(self.javatest_pypaths,[pypath.get_bld().abspath()])
				extend_unique(self.javatest_dep_nodes,[o for task in getattr(tg,'tasks',[])for o in getattr(task,'outputs',[])])
			else:
				extend_unique(self.javatest_dep_nodes,tg.source)
				extend_unique(self.javatest_pypaths,[pypath.abspath()])
		if getattr(tg,'link_task',None):
			if not isinstance(tg.link_task,ccroot.stlink_task):
				extend_unique(self.javatest_dep_nodes,tg.link_task.outputs)
				extend_unique(self.javatest_libpaths,tg.link_task.env.LIBPATH)
				if'pyext'in tg.features:
					extend_unique(self.javatest_libpaths,tg.link_task.env.LIBPATH_PYEXT)
				else:
					extend_unique(self.javatest_libpaths,[tg.link_task.outputs[0].parent.abspath()])
		if'javac'in tg.features or'jar'in tg.features:
			if hasattr(tg,'jar_task'):
				extend_unique(self.javatest_dep_nodes,tg.jar_task.outputs)
			else:
				if hasattr(tg,'outdir'):
					base_node=tg.outdir
				else:
					base_node=tg.path.get_bld()
				self.javatest_dep_nodes.extend([dx for dx in base_node.ant_glob(JAR_RE,remove=False,quiet=True)])
@TaskGen.feature('javatest')
@TaskGen.after_method('apply_java','use_javac_files','set_classpath','javatest_process_use')
def make_javatest(self):
	tsk=self.create_task('utest')
	tsk.set_run_after(self.javac_task)
	tsk.dep_nodes.extend(self.javatest_dep_nodes)
	if getattr(self,'jtest_source',None):
		tsk.inputs=self.to_nodes(self.jtest_source)
	else:
		if self.javac_task.srcdir[0].exists():
			tsk.inputs=self.javac_task.srcdir[0].ant_glob('**/*.java',remove=False)
	if getattr(self,'ut_str',None):
		self.ut_run,lst=Task.compile_fun(self.ut_str,shell=getattr(self,'ut_shell',False))
		tsk.vars=lst+tsk.vars
	if getattr(self,'ut_cwd',None):
		if isinstance(self.ut_cwd,str):
			if os.path.isabs(self.ut_cwd):
				self.ut_cwd=self.bld.root.make_node(self.ut_cwd)
			else:
				self.ut_cwd=self.path.make_node(self.ut_cwd)
	else:
		self.ut_cwd=self.bld.bldnode
	tsk.env.CLASSPATH=':'.join(self.env.CLASSPATH)+':'+self.outdir.abspath()
	if not self.ut_cwd.exists():
		self.ut_cwd.mkdir()
	if not hasattr(self,'ut_env'):
		self.ut_env=dict(os.environ)
		def add_paths(var,lst):
			lst=[str(n)for n in lst]
			Logs.debug("ut: %s: Adding paths %s=%s",self,var,lst)
			self.ut_env[var]=os.pathsep.join(lst)+os.pathsep+self.ut_env.get(var,'')
		add_paths('PYTHONPATH',self.javatest_pypaths)
		if Utils.is_win32:
			add_paths('PATH',self.javatest_libpaths)
		elif Utils.unversioned_sys_platform()=='darwin':
			add_paths('DYLD_LIBRARY_PATH',self.javatest_libpaths)
			add_paths('LD_LIBRARY_PATH',self.javatest_libpaths)
		else:
			add_paths('LD_LIBRARY_PATH',self.javatest_libpaths)
def configure(ctx):
	cp=ctx.env.CLASSPATH or'.'
	if getattr(Options.options,'jtpath',None):
		ctx.env.CLASSPATH_JAVATEST=getattr(Options.options,'jtpath').split(':')
		cp+=':'+getattr(Options.options,'jtpath')
	if getattr(Options.options,'jtrunner',None):
		ctx.env.JTRUNNER=getattr(Options.options,'jtrunner')
	if ctx.check_java_class(ctx.env.JTRUNNER,with_classpath=cp):
		ctx.fatal('Could not run test class %r'%ctx.env.JTRUNNER)
def options(opt):
	opt.add_option('--jtpath',action='store',default='',dest='jtpath',help='Path to jar(s) needed for javatest execution, colon separated, if not in the system CLASSPATH')
	opt.add_option('--jtrunner',action='store',default='org.testng.TestNG',dest='jtrunner',help='Class to run javatest test [default: org.testng.TestNG]')
