# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

import os
from waflib import Logs,Build
from waflib.Runner import Parallel
DYNAMIC_EXT=[]
MOC_H_EXTS='.cpp .cxx .hpp .hxx .h'.split()
def can_delete(node):
	if not node.name.endswith('.moc'):
		return os.path.isfile(node.abspath())
	base=node.name[:-4]
	p1=node.parent.get_src()
	p2=node.parent.get_bld()
	for k in MOC_H_EXTS:
		h_name=base+k
		n=p1.search_node(h_name)
		if n:
			return False
		n=p2.search_node(h_name)
		if n:
			return False
		if base.endswith(k):
			return False
	return True
def stale_rec(node,nodes):
	if node.abspath()in node.ctx.env[Build.CFG_FILES]:
		return
	if getattr(node,'children',[]):
		for x in list(node.children.values()):
			if x.name!="c4che":
				stale_rec(x,nodes)
	else:
		for ext in DYNAMIC_EXT:
			if node.name.endswith(ext):
				break
		else:
			if not node in nodes:
				if can_delete(node):
					Logs.warn('Removing stale file -> %r',node)
					node.delete()
old=Parallel.refill_task_list
def refill_task_list(self):
	iit=old(self)
	bld=self.bld
	if getattr(self,'stale_done',False):
		return iit
	self.stale_done=True
	if bld.targets not in('','*'):
		return iit
	if getattr(bld,'post_mode')!=Build.POST_AT_ONCE:
		Logs.warn('waflib.extras.stale is incompatible with dynamic builds')
		return iit
	nodes=[]
	for group in bld.groups:
		for tg in group:
			try:
				nodes.extend(tg.outputs)
			except AttributeError:
				for task in tg.tasks:
					try:
						nodes.extend(task.outputs)
					except AttributeError:
						pass
	stale_rec(bld.bldnode,nodes)
	return iit
Parallel.refill_task_list=refill_task_list
